
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Invoice_linesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const invoice_lines = await db.invoice_lines.create(
            {
                id: data.id || undefined,
        
        line_description: data.line_description
        ||
        null
            ,
            
        quantity: data.quantity
        ||
        null
            ,
            
        unit_price: data.unit_price
        ||
        null
            ,
            
        discount_rate: data.discount_rate
        ||
        null
            ,
            
        line_subtotal: data.line_subtotal
        ||
        null
            ,
            
        tax_amount: data.tax_amount
        ||
        null
            ,
            
        line_total: data.line_total
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await invoice_lines.setInvoice( data.invoice || null, {
            transaction,
        });
        
        await invoice_lines.setProduct( data.product || null, {
            transaction,
        });
        
        await invoice_lines.setTax_code( data.tax_code || null, {
            transaction,
        });
        
        await invoice_lines.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return invoice_lines;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const invoice_linesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                line_description: item.line_description
            ||
            null
            ,
            
                quantity: item.quantity
            ||
            null
            ,
            
                unit_price: item.unit_price
            ||
            null
            ,
            
                discount_rate: item.discount_rate
            ||
            null
            ,
            
                line_subtotal: item.line_subtotal
            ||
            null
            ,
            
                tax_amount: item.tax_amount
            ||
            null
            ,
            
                line_total: item.line_total
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const invoice_lines = await db.invoice_lines.bulkCreate(invoice_linesData, { transaction });

        // For each item created, replace relation files
        

        return invoice_lines;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const invoice_lines = await db.invoice_lines.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.line_description !== undefined) updatePayload.line_description = data.line_description;
        
        
        if (data.quantity !== undefined) updatePayload.quantity = data.quantity;
        
        
        if (data.unit_price !== undefined) updatePayload.unit_price = data.unit_price;
        
        
        if (data.discount_rate !== undefined) updatePayload.discount_rate = data.discount_rate;
        
        
        if (data.line_subtotal !== undefined) updatePayload.line_subtotal = data.line_subtotal;
        
        
        if (data.tax_amount !== undefined) updatePayload.tax_amount = data.tax_amount;
        
        
        if (data.line_total !== undefined) updatePayload.line_total = data.line_total;
        
        
        updatePayload.updatedById = currentUser.id;

        await invoice_lines.update(updatePayload, {transaction});

        
        
        if (data.invoice !== undefined) {
            await invoice_lines.setInvoice(
              
              data.invoice,
              
              { transaction }
            );
        }
        
        if (data.product !== undefined) {
            await invoice_lines.setProduct(
              
              data.product,
              
              { transaction }
            );
        }
        
        if (data.tax_code !== undefined) {
            await invoice_lines.setTax_code(
              
              data.tax_code,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await invoice_lines.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return invoice_lines;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const invoice_lines = await db.invoice_lines.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of invoice_lines) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of invoice_lines) {
                await record.destroy({transaction});
            }
        });


        return invoice_lines;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const invoice_lines = await db.invoice_lines.findByPk(id, options);

        await invoice_lines.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await invoice_lines.destroy({
            transaction
        });

        return invoice_lines;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const invoice_lines = await db.invoice_lines.findOne(
            { where },
            { transaction },
        );

        if (!invoice_lines) {
            return invoice_lines;
        }

        const output = invoice_lines.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.invoice = await invoice_lines.getInvoice({
            transaction
        });
        
        
        output.product = await invoice_lines.getProduct({
            transaction
        });
        
        
        output.tax_code = await invoice_lines.getTax_code({
            transaction
        });
        
        
        output.organizations = await invoice_lines.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.invoices,
        as: 'invoice',
        
        where: filter.invoice ? {
          [Op.or]: [
            { id: { [Op.in]: filter.invoice.split('|').map(term => Utils.uuid(term)) } },
            {
              invoice_number: {
                [Op.or]: filter.invoice.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.products,
        as: 'product',
        
        where: filter.product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.tax_codes,
        as: 'tax_code',
        
        where: filter.tax_code ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tax_code.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tax_code.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.line_description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'invoice_lines',
                        'line_description',
                        filter.line_description,
                    ),
                };
            }
            

            
            

            
            if (filter.quantityRange) {
                const [start, end] = filter.quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.unit_priceRange) {
                const [start, end] = filter.unit_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    unit_price: {
                    ...where.unit_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    unit_price: {
                    ...where.unit_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.discount_rateRange) {
                const [start, end] = filter.discount_rateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    discount_rate: {
                    ...where.discount_rate,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    discount_rate: {
                    ...where.discount_rate,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.line_subtotalRange) {
                const [start, end] = filter.line_subtotalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    line_subtotal: {
                    ...where.line_subtotal,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    line_subtotal: {
                    ...where.line_subtotal,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.tax_amountRange) {
                const [start, end] = filter.tax_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    tax_amount: {
                    ...where.tax_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    tax_amount: {
                    ...where.tax_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.line_totalRange) {
                const [start, end] = filter.line_totalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    line_total: {
                    ...where.line_total,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    line_total: {
                    ...where.line_total,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.invoice_lines.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'invoice_lines',
                        'line_description',
                        query,
                    ),
                ],
            };
        }

        const records = await db.invoice_lines.findAll({
            attributes: [ 'id', 'line_description' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['line_description', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.line_description,
        }));
    }

    
};

